[![Build Status](https://travis-ci.org/fw4spl-org/fw4spl.svg?branch=fw4spl_0.11.0)](https://travis-ci.org/fw4spl-org/fw4spl)

Description
===========

**FW4SPL** is a framework for fast and easy creation of applications, mainly in the medical imaging field.
It includes various features such as 2D and 3D digital image processing, visualization, augmented reality and medical interaction simulation. It runs on many different environments (Windows, linux, OSX), is written in C++, and features rapid interface design using XML files. 
It is freely available under open source license (LGPL).

See [documentation](http://fw4spl.readthedocs.org/) for more details.

Applications
============

*FW4SPL* comes with **VRRender**, a medical image and segmentation viewer. It supports many format including DICOM, vtk, inr, etc...

Lots of **tutorials** and **examples** can also be found in the *Samples/* directory. The tutorials can help you to learn smoothly how to use *FW4SPL*, detailed steps are described [there](http://fw4spl.readthedocs.io/en/fw4spl_0.11.0/Tutorials/index.html).

Install
=======

See how to install fw4spl [here](http://fw4spl.readthedocs.org/en/fw4spl_0.11.0/Installation/index.html)

Documentation
=============

* **documentation**: http://fw4spl.readthedocs.org/
* **tutorials**: http://fw4spl.readthedocs.io/en/fw4spl_0.11.0/Tutorials/index.html
* **doxygen**: http://fw4spl-org.github.io/fw4spl-dox/
* **blog**: http://fw4spl-org.github.io/fw4spl-blog/

Annex
=====

* [fw4spl-deps](https://github.com/fw4spl-org/fw4spl-deps): contains the scripts to compile the external libraries used by fw4spl (Boost, VTK, ITK, Qt, ...)
* [fw4spl-ar](https://github.com/fw4spl-org/fw4spl-ar): fw4spl repository that contains additional functionalities for Augmented Reality
* [fw4spl-droid](https://github.com/fw4spl-org/fw4spl-droid): fw4spl repository that brings Android support.
* [fw4spl-ogre](https://github.com/fw4spl-org/fw4spl-ogre): fw4spl repository that offers a new 3D rendering backend using [Ogre3D](http://www.ogre3d.org/).
* [fw4spl community](https://github.com/fw4spl-org): contains various repositories associated with fw4spl (extensions, dependencies, ...)
